Java Implementation of CA trees 
===============================

Code
----

The CATree implementations are located in `src/main/java/se/uu/collection/`.
`CATreeMapSTDR.java` contains the plain CA tree implementation with 
AVL trees as the sequential data stucture and `FatCATreeMapSTDR.java`
contain the implementation with skip lists with fat nodes as sequential
data structure. `src/test/java/se/uu/bench/` contain the benchmark
implementation. Code for running the benchmark are located in
`benchmark_tools`.

Other related data structures are located in subdirectories of
`src/main/java/`.


Compile and Test
----------------

**Requirements**

* The [sbt](http://www.scala-sbt.org/) build tool
* [JDK 8](http://www.oracle.com/technetwork/java/javase/downloads/jdk8-downloads-2133151.html) or greater

**Compilation**

When the requirements are installed the following command can be used
to compile everything and run the tests (the tests can take a few
minutes to complete depending on the system):

`sbt test`

Benchmarking
------------

[Python](https://www.python.org/) scripts to run benchmarks are
located in `benchmark_tools`. Edit `run_benchmarks.py` to configure
the benchmark parameters and `benchmark_runner.py` to configure JVM
parameters. Run the benchmarks with the command:

`python run_benchmarks.py`

This will put the benchmark data in a directory named after the time
the benchmark was started, e.g `2014_08_05_16_03_14`. You need to
install [matplotlib](http://matplotlib.org/) to produce graphs from
the data. To produce graphs for the benchmark go into the directory
and run:

`python graph_producer_file.py`

(You might need to edit `benchmark_tools/produce_graphs.py` to include
all data structures that has been benchmarked.)

The SnapTree can be obtained from:
https://github.com/nbronson/snaptree/

The lock free k-ary search tree with range query support can be optained from:
http://www.cs.utoronto.ca/~tabrown/kstrq/

