#!/usr/bin/python

import sys
import os
import datetime
import subprocess
import re

import sys

bin_dir_path = os.path.dirname(os.path.realpath(__file__))

sys.path.append(os.path.join(bin_dir_path, '..', 'src', 'lock'))

parameters = sys.argv

parameters.pop(0)

if len(parameters) < 0:
    print """Not enough parameters:

Look at bin/run_benchmarks_on_intel_i7.py and
bin/run_benchmarks_on_sandy.py for examples and explanations of
parameters.

"""
    sys.exit()


output_dir_base = parameters.pop(0)

if output_dir_base=='standard':
    output_dir_base = (datetime.datetime.now().strftime("%Y.%m.%d.%H.%M.%S")) #subprocess.check_output(['git', 'rev-parse', 'HEAD'])[-11:-1] 

benchmark_name = parameters.pop(0)

data_structure_names = parameters.pop(0).split(',')

thread_counts = parameters.pop(0).split(",")

pinning = parameters.pop(0)

benchmark_parameters_list = " ".join(parameters).split(",")

for benchmark_parameters in benchmark_parameters_list:
    if not os.path.exists(output_dir_base):
        os.makedirs(output_dir_base)
    output_file_str = (output_dir_base + '/' + benchmark_name + '_' + benchmark_parameters.replace(' ', '@'))
    with open(output_file_str, "a") as outfile:
        for data_structure_name in data_structure_names:
            sys.stderr.write( "\n\nSTARTING BENCHMARK " + benchmark_name + " for " + data_structure_name + " with parameters " + benchmark_parameters + "\n\n")
            for thread_count in thread_counts:
                command = ['java',
                           '-Xmx4g',
                           '-Xms4g',
                           '-server',
                           '-d64',
                           '-cp',
                           '../target/scala-2.11/test-classes/:../target/scala-2.11/classes/',
                           benchmark_name,
                           data_structure_name,
                           str(thread_count)] + benchmark_parameters.split(' ')
                if pinning=='no':
                    sys.stderr.write(",".join(command))
                    process = subprocess.Popen(command, stdout=outfile)
                    process.wait()
                else:
                    thread_count = int(thread_count)
                    nomactrl = None
                    if thread_count > 48:
                        nomactrl = ['numactl', '--cpunodebind=0,1,2,3']#--membind=nodes
                    elif thread_count > 32:
                        nomactrl = ['numactl', '--cpunodebind=0,1,2']
                    elif thread_count > 16:
                        nomactrl = ['numactl', '--cpunodebind=0,1']
                    else:
                        nomactrl = ['numactl', '--cpunodebind=0']
                    sys.stderr.write(",".join(nomactrl + command))
                    process = subprocess.Popen(nomactrl + command, stdout=outfile)
                    process.wait()
            sys.stderr.write( "\n\nBENCHMARK DONE!\n\n")
